#include <stdio.h>
#include <io.h>
#include <winsock2.h>
#include "MindtelSocket.h"
#include "FormValues.h"

static void usage() {
	printf( "Usage: mserver <port>\n" );
}

void log_error( char* s ) {
	printf( "%s\n", s );
}

void log_message( const char* s ) {
	printf( "%s\n", s );
}
void log_message1( const char* s, const char* s1 ) {
	printf( "%s %s\n", s, s1 );
}

void log_message2( const char* s, const char* s1, const char* s2 ) {
	printf( "%s%s%s\n", s, s1, s2 );
}
void log_messagei2( char* s, int i1, int i2 ) {
	printf( "%s, %d %d\n", s, i1, i2 );
}
void log_message_is( const char* s, int i, const char* s2 ) {
	printf( "%s, %d, %s\n", s, i, s2 );
}

/*
 *  POST accesses are external method calls, since what to do with
 *  the FORM data is application specific.
 */
//ndtelSocketServer mainServer(3333);


bool doPost( char* pageToGet, char* buf, MindtelSocketServer* theServer ) {
	FormValues fv( buf );
	fv.Dump();
	//theServer = &mainServer;
	log_message2("doPost called with page:::", pageToGet, ":::" );
	if ( fv.doneWithHeader() ) {
		char* neatview_command = fv.grabValue( "neatview_command" );
		if ( neatview_command != NULL ) {
			log_message1( "neatview_command is: ", neatview_command );
			if ( strcmp( neatview_command, "generate_map" ) == 0 ) {
				log_message( "command is generate_map" );
				char* whichMap = fv.grabValue( "whichMap" );
				char* x = fv.grabValue( "boxX" );
				char* y = fv.grabValue( "boxY" );
				char* width = fv.grabValue( "boxWidth" );
				char* height = fv.grabValue( "boxHeight" );
				char* boxLatitude = fv.grabValue( "boxLatitude" );
				char* boxLongitude = fv.grabValue( "boxLongitude" );
				char* boxWidth = fv.grabValue( "boxWidth" );
				if (( whichMap != NULL ) && ( x != NULL ) && ( y != NULL ) && ( width != NULL ) && ( height != NULL )) {
					log_message1("got whichMap", whichMap );
					log_message1("got x", x );
					log_message1("got y", y );
					log_message1("got width", width );
					log_message1("got height", height );
				} else {
					log_message("doPost: didn't get expected form field values" );
				}
			} else if ( strcmp( neatview_command, "tides_search" ) == 0 ) {
				log_message( "do a tides search" );
			} else {
				log_message1( "unknown neatview_command", neatview_command );
			}
		} else {
			log_message( "neatview_command was not found" );
		}
	} else {
		log_message("doPost: its not done with header" );
	}
	if ( fv.doneWithHeader() ) {
		theServer->GetPage( pageToGet );
	}

	return( fv.doneWithHeader() );
}

//
//  Create and run a server on a particular port.
//
int main( int argc, char* argv[] ) {
	if ( argc != 2 ) {
		usage();
		exit( 0 );
	} else {
		int port = atoi( argv[1] );
		if ( port == 0 ) {
			usage();
			exit( 0 );
		}
		printf( "Creating Server\n" );
		MindtelSocketServer server( port );
		printf( "Running Server\n" );
		server.Run();
		//mainServer.Run();
		printf( "Run is complete\n" );
	}
	return( 0 );
}
